<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 2158 $
 * $Id: FactoryListIterator.class.php 2158 2008-09-15 23:26:15Z ipso $
 * $Date: 2008-09-15 16:26:15 -0700 (Mon, 15 Sep 2008) $
 */

/**
 * @package Core
 */
class FactoryListIterator implements Iterator {
    private $obj;
	private $rs;
	private $class_name;

    function __construct($obj) {
		$this->class_name = get_class($obj);

		if ( isset($obj->rs) ) {
			$this->rs = $obj->rs;
		}

		$this->obj = $obj;
    }

    function rewind() {
		if ( isset($this->obj->rs) ) {
			$this->obj->rs->MoveFirst();
		}

		return FALSE;
    }

    function valid() {
		if ( isset($this->obj->rs) ) {
			return !$this->obj->rs->EOF;
		}

		return FALSE;
    }

    function key() {
        return $this->obj->rs->_currentRow;
    }

    function current() {
		if ( isset($this->obj->rs) ) { //Stop some warnings from coming up?

			//This automatically resets the object during each iteration in a foreach()
			//Without this, data can persist and cause undesirable results.

			$this->obj = new $this->class_name();

			$this->obj->rs = $this->rs;

			$this->obj->data = $this->obj->rs->fields; //Orignal
		}

		return $this->obj;
    }

    function next() {
        $this->obj->rs->MoveNext();
    }

}
?>
